package org.openxma.addons.ui.table.customizer.xma.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.component.*;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.list.*;
import at.spardat.xma.mdl.table.*;

/**
 * This class implements the generic client part of TableCustomizerPage.
 * It implements the widgets and models of the page.
 *
 */
public abstract class TableCustomizerPageGen extends DialogPage {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    private Scaler scaler = null;
    Button applyAndPersistButtonW;
    Button cancelButtonW;
    Button applyButtonW;
    Group uiGroupW;
    List availableColumnsW;
    IListWMClient availableColumns;
    Label availableColumnsL;
    Table visibleColumnsTableW;
    at.spardat.xma.mdl.table.TableLayoutManager visibleColumnsTableWLM;
    ITableWMClient visibleColumnsTable;
    static final int FILTERICON = 0;
    static final int COLTXT = 1;
    Button addButtonW;
    Button removeButtonW;
    Label visibleColumnsL;
    Label vsep1W;
    Button upButtonW;
    Button downButtonW;
    Button setFilterButtonW;
    Button removeFilterButtonW;
    Button removeAllFilterButtonW;
    Group sortGroupW;
    Button sortUpButtonW;
    Button sortDownButtonW;
    Label vsep2W;
    Table sortingTableW;
    at.spardat.xma.mdl.table.TableLayoutManager sortingTableWLM;
    ITableWMClient sortingTable;
    static final int ICON = 0;
    static final int COLNAME = 1;
    Table sortingCandidatesTableW;
    at.spardat.xma.mdl.table.TableLayoutManager sortingCandidatesTableWLM;
    ITableWMClient sortingCandidatesTable;
    static final int SORTCANDIDATECOLUMN = 0;
    Button addSortButtonW;
    Button removeSortButtonW;
    Label sortCandidateLabel;
    Label sortColumnsLabel;
    Button removeAllSortButtonW;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the TableCustomizerPageGen.
     * @param parent the parent page
     */
    public TableCustomizerPageGen(PageClient parent) {
        super(parent,false,SWT.APPLICATION_MODAL|SWT.CLOSE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the TableCustomizerPageGen.
     * @param component the component this page belongs to
     */
    public TableCustomizerPageGen(ComponentClient component) {
        super(component,false,SWT.APPLICATION_MODAL|SWT.CLOSE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the TableCustomizerPageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     */
    public TableCustomizerPageGen(ComponentClient component, Shell parentShell) {
        super(component,parentShell,false,SWT.APPLICATION_MODAL|SWT.CLOSE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the TableCustomizerPageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     * @param modal the SWT-style for the desired modality
     */
    public TableCustomizerPageGen(ComponentClient component, Shell parentShell, int modal) {
        super(component,parentShell,false,modal|SWT.CLOSE|SWT.TITLE);
        createModels();
    }


    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.addons.ui.table.customizer.xma.client.TableCustomizerComp",getGenPageLocale());
        }
        return genPageMessages;
    }

    /*
     * returns the scaler used for this page
    */
    final protected Scaler getScaler() {
        if (scaler == null) {
            scaler = Scaler.getInstance(getComposite());
        }
        return scaler;
    }

    /**
     * Gives the URI of the help for this page
     * This URI is relative to the download-URI of the component
     * @return the relative URI of the help for this page
     */
    public String getHelpUri() {
        return "help/org/openxma/addons/ui/table/customizer/xma/TableCustomizerPage.html";
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        availableColumns = new ListWMClient((short) 0,this, ListWMClient.S_NULL);
        visibleColumnsTable = new TableWMClient((short) 1,this,2,TableWMClient.S_NULL|TableWM.S_ONE_WAY);
        sortingTable = new TableWMClient((short) 2,this,2,TableWMClient.S_NULL|TableWM.S_ONE_WAY);
        sortingCandidatesTable = new TableWMClient((short) 3,this,1,TableWMClient.S_NULL|TableWM.S_ONE_WAY);

        widgetModels = new WModel[] { (WModel) availableColumns, (WModel) visibleColumnsTable, (WModel) sortingTable, (WModel) sortingCandidatesTable };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        availableColumns = null;
        visibleColumnsTable = null;
        sortingTable = null;
        sortingCandidatesTable = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return TableCustomizerComp.TableCustomizerPageClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public TableCustomizerComp getTypedComponent() {
        return (TableCustomizerComp) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = getScaler();

        final Shell shell = getShell();
        if(getDialog()==this) {
            shell.setText(getGenPageMessages().getString("TableCustomizerPage"));
            shell.addHelpListener(adapter);
        } else {
            getComposite().addHelpListener(adapter);
        }
        Composite customizerPageCompW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        customizerPageCompW.setLayout(layout);

        applyAndPersistButtonW = new Button(customizerPageCompW, SWT.PUSH|SWT.CENTER);
        applyAndPersistButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.applyAndPersistButtonW"));
        applyAndPersistButtonW.setData("WIDGET_ID","applyAndPersistButtonW");
        applyAndPersistButtonW.addSelectionListener(adapter);

        cancelButtonW = new Button(customizerPageCompW, SWT.PUSH|SWT.CENTER);
        cancelButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.cancelButtonW"));
        cancelButtonW.setData("WIDGET_ID","cancelButtonW");
        cancelButtonW.addSelectionListener(adapter);

        applyButtonW = new Button(customizerPageCompW, SWT.PUSH|SWT.CENTER);
        applyButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.applyButtonW"));
        applyButtonW.setData("WIDGET_ID","applyButtonW");
        applyButtonW.addSelectionListener(adapter);

        uiGroupW = new Group(customizerPageCompW,SWT.NONE);
        uiGroupW.setText(getGenPageMessages().getString("TableCustomizerPage.uiGroupW"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        uiGroupW.setLayout(layout);

        availableColumnsL = new Label(uiGroupW,SWT.LEFT);
        availableColumnsL.setText(getGenPageMessages().getString("TableCustomizerPage.availableColumnsL"));
        availableColumnsL.setData("WIDGET_ID","availableColumnsL");

        availableColumnsW = new List(uiGroupW,SWT.SINGLE|SWT.BORDER|SWT.H_SCROLL|SWT.V_SCROLL);
        availableColumnsW.setData("WIDGET_ID","availableColumnsW");
        availableColumnsW.addFocusListener(adapter);
        availableColumnsW.addSelectionListener(adapter);

        visibleColumnsTableW = new Table(uiGroupW,SWT.SINGLE|SWT.BORDER|SWT.FULL_SELECTION
);
        visibleColumnsTableW.setData("WIDGET_ID","visibleColumnsTableW");
        visibleColumnsTableW.addSelectionListener(adapter);
        TableColumn filterIcon = new TableColumn(visibleColumnsTableW,SWT.LEFT);
        filterIcon.setResizable(false);
        filterIcon.setText(getGenPageMessages().getString("TableCustomizerPage.filterIcon"));
        filterIcon.addSelectionListener(adapter);
        TableColumn colTxt = new TableColumn(visibleColumnsTableW,SWT.LEFT);
        colTxt.setResizable(false);
        colTxt.setText(getGenPageMessages().getString("TableCustomizerPage.colTxt"));
        colTxt.addSelectionListener(adapter);
        visibleColumnsTableW.addMouseListener(adapter);
        Menu visibleColumnsTableWCM = new Menu(visibleColumnsTableW.getShell());
        MenuItem visibleColumnsTableWCMI = new MenuItem(visibleColumnsTableWCM, SWT.PUSH);
        visibleColumnsTableWCMI.setText("Copy text");
        visibleColumnsTableWCMI.addSelectionListener(adapter);
        visibleColumnsTableW.setMenu(visibleColumnsTableWCM);
        visibleColumnsTableWLM = new at.spardat.xma.mdl.table.TableLayoutManager();
        visibleColumnsTableWLM.manageTable(visibleColumnsTableW,at.spardat.xma.mdl.table.TableLayoutManager.NONE);
        visibleColumnsTableWLM.setMinLimit(scaler.convertXToCurrent(10));
        visibleColumnsTableWLM.setStrechColumn(1);
        visibleColumnsTableWLM.setAbsolutWidth(0,scaler.convertXToCurrent(20));

        addButtonW = new Button(uiGroupW, SWT.PUSH|SWT.CENTER);
        addButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.addButtonW"));
        addButtonW.setImage(getComponent().getImage("org/openxma/addons/ui/table/customizer/xma/client/images/arrow_right.png"));
        addButtonW.setData("WIDGET_ID","addButtonW");
        addButtonW.addSelectionListener(adapter);

        removeButtonW = new Button(uiGroupW, SWT.PUSH|SWT.CENTER);
        removeButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.removeButtonW"));
        removeButtonW.setImage(getComponent().getImage("org/openxma/addons/ui/table/customizer/xma/client/images/arrow_left.png"));
        removeButtonW.setData("WIDGET_ID","removeButtonW");
        removeButtonW.addSelectionListener(adapter);

        visibleColumnsL = new Label(uiGroupW,SWT.LEFT);
        visibleColumnsL.setText(getGenPageMessages().getString("TableCustomizerPage.visibleColumnsL"));
        visibleColumnsL.setData("WIDGET_ID","visibleColumnsL");

        vsep1W = new Label (uiGroupW,SWT.SEPARATOR|SWT.VERTICAL);
        vsep1W.setVisible(false);
        vsep1W.setData("WIDGET_ID","vsep1W");

        upButtonW = new Button(uiGroupW, SWT.PUSH|SWT.CENTER);
        upButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.upButtonW"));
        upButtonW.setImage(getComponent().getImage("org/openxma/addons/ui/table/customizer/xma/client/images/arrow_up.png"));
        upButtonW.setData("WIDGET_ID","upButtonW");
        upButtonW.addSelectionListener(adapter);

        downButtonW = new Button(uiGroupW, SWT.PUSH|SWT.CENTER);
        downButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.downButtonW"));
        downButtonW.setImage(getComponent().getImage("org/openxma/addons/ui/table/customizer/xma/client/images/arrow_down.png"));
        downButtonW.setData("WIDGET_ID","downButtonW");
        downButtonW.addSelectionListener(adapter);

        setFilterButtonW = new Button(uiGroupW, SWT.PUSH|SWT.CENTER);
        setFilterButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.setFilterButtonW"));
        setFilterButtonW.setData("WIDGET_ID","setFilterButtonW");
        setFilterButtonW.addSelectionListener(adapter);

        removeFilterButtonW = new Button(uiGroupW, SWT.PUSH|SWT.CENTER);
        removeFilterButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.removeFilterButtonW"));
        removeFilterButtonW.setData("WIDGET_ID","removeFilterButtonW");
        removeFilterButtonW.addSelectionListener(adapter);

        removeAllFilterButtonW = new Button(uiGroupW, SWT.PUSH|SWT.CENTER);
        removeAllFilterButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.removeAllFilterButtonW"));
        removeAllFilterButtonW.setData("WIDGET_ID","removeAllFilterButtonW");
        removeAllFilterButtonW.addSelectionListener(adapter);

        sortGroupW = new Group(customizerPageCompW,SWT.NONE);
        sortGroupW.setText(getGenPageMessages().getString("TableCustomizerPage.sortGroupW"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        sortGroupW.setLayout(layout);

        sortUpButtonW = new Button(sortGroupW, SWT.PUSH|SWT.CENTER);
        sortUpButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.sortUpButtonW"));
        sortUpButtonW.setImage(getComponent().getImage("org/openxma/addons/ui/table/customizer/xma/client/images/arrow_up.png"));
        sortUpButtonW.setData("WIDGET_ID","sortUpButtonW");
        sortUpButtonW.addSelectionListener(adapter);

        sortDownButtonW = new Button(sortGroupW, SWT.PUSH|SWT.CENTER);
        sortDownButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.sortDownButtonW"));
        sortDownButtonW.setImage(getComponent().getImage("org/openxma/addons/ui/table/customizer/xma/client/images/arrow_down.png"));
        sortDownButtonW.setData("WIDGET_ID","sortDownButtonW");
        sortDownButtonW.addSelectionListener(adapter);

        vsep2W = new Label (sortGroupW,SWT.SEPARATOR|SWT.VERTICAL);
        vsep2W.setVisible(false);
        vsep2W.setData("WIDGET_ID","vsep2W");

        sortingTableW = new Table(sortGroupW,SWT.SINGLE|SWT.BORDER|SWT.FULL_SELECTION
);
        sortingTableW.setData("WIDGET_ID","sortingTableW");
        sortingTableW.addSelectionListener(adapter);
        TableColumn icon = new TableColumn(sortingTableW,SWT.LEFT);
        icon.setResizable(false);
        icon.addSelectionListener(adapter);
        TableColumn colName = new TableColumn(sortingTableW,SWT.LEFT);
        colName.setResizable(false);
        colName.setText(getGenPageMessages().getString("TableCustomizerPage.colName"));
        colName.addSelectionListener(adapter);
        sortingTableW.addMouseListener(adapter);
        Menu sortingTableWCM = new Menu(sortingTableW.getShell());
        MenuItem sortingTableWCMI = new MenuItem(sortingTableWCM, SWT.PUSH);
        sortingTableWCMI.setText("Copy text");
        sortingTableWCMI.addSelectionListener(adapter);
        sortingTableW.setMenu(sortingTableWCM);
        sortingTableWLM = new at.spardat.xma.mdl.table.TableLayoutManager();
        sortingTableWLM.manageTable(sortingTableW,at.spardat.xma.mdl.table.TableLayoutManager.NONE);
        sortingTableWLM.setMinLimit(scaler.convertXToCurrent(10));
        sortingTableWLM.setStrechColumn(1);
        sortingTableWLM.setAbsolutWidth(0,scaler.convertXToCurrent(20));

        sortingCandidatesTableW = new Table(sortGroupW,SWT.SINGLE|SWT.BORDER|SWT.FULL_SELECTION
);
        sortingCandidatesTableW.setData("WIDGET_ID","sortingCandidatesTableW");
        sortingCandidatesTableW.addSelectionListener(adapter);
        TableColumn sortCandidateColumn = new TableColumn(sortingCandidatesTableW,SWT.LEFT);
        sortCandidateColumn.setResizable(false);
        sortCandidateColumn.setText(getGenPageMessages().getString("TableCustomizerPage.sortCandidateColumn"));
        sortCandidateColumn.addSelectionListener(adapter);
        sortingCandidatesTableW.addMouseListener(adapter);
        Menu sortingCandidatesTableWCM = new Menu(sortingCandidatesTableW.getShell());
        MenuItem sortingCandidatesTableWCMI = new MenuItem(sortingCandidatesTableWCM, SWT.PUSH);
        sortingCandidatesTableWCMI.setText("Copy text");
        sortingCandidatesTableWCMI.addSelectionListener(adapter);
        sortingCandidatesTableW.setMenu(sortingCandidatesTableWCM);
        sortingCandidatesTableWLM = new at.spardat.xma.mdl.table.TableLayoutManager();
        sortingCandidatesTableWLM.manageTable(sortingCandidatesTableW,at.spardat.xma.mdl.table.TableLayoutManager.NONE);
        sortingCandidatesTableWLM.setMinLimit(scaler.convertXToCurrent(10));
        sortingCandidatesTableWLM.setStrechColumn(0);

        addSortButtonW = new Button(sortGroupW, SWT.PUSH|SWT.CENTER);
        addSortButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.addSortButtonW"));
        addSortButtonW.setImage(getComponent().getImage("org/openxma/addons/ui/table/customizer/xma/client/images/arrow_right.png"));
        addSortButtonW.setData("WIDGET_ID","addSortButtonW");
        addSortButtonW.addSelectionListener(adapter);

        removeSortButtonW = new Button(sortGroupW, SWT.PUSH|SWT.CENTER);
        removeSortButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.removeSortButtonW"));
        removeSortButtonW.setImage(getComponent().getImage("org/openxma/addons/ui/table/customizer/xma/client/images/arrow_left.png"));
        removeSortButtonW.setData("WIDGET_ID","removeSortButtonW");
        removeSortButtonW.addSelectionListener(adapter);

        sortCandidateLabel = new Label(sortGroupW,SWT.LEFT);
        sortCandidateLabel.setText(getGenPageMessages().getString("TableCustomizerPage.sortCandidateLabel"));
        sortCandidateLabel.setData("WIDGET_ID","sortCandidateLabel");

        sortColumnsLabel = new Label(sortGroupW,SWT.LEFT);
        sortColumnsLabel.setText(getGenPageMessages().getString("TableCustomizerPage.sortColumnsLabel"));
        sortColumnsLabel.setData("WIDGET_ID","sortColumnsLabel");

        removeAllSortButtonW = new Button(sortGroupW, SWT.PUSH|SWT.CENTER);
        removeAllSortButtonW.setText(getGenPageMessages().getString("TableCustomizerPage.removeAllSortButtonW"));
        removeAllSortButtonW.setData("WIDGET_ID","removeAllSortButtonW");
        removeAllSortButtonW.addSelectionListener(adapter);

        widgets = new Control[] { applyAndPersistButtonW, cancelButtonW, applyButtonW, uiGroupW, availableColumnsW, availableColumnsL, visibleColumnsTableW, addButtonW, removeButtonW, visibleColumnsL, vsep1W, upButtonW, downButtonW, setFilterButtonW, removeFilterButtonW, removeAllFilterButtonW, sortGroupW, sortUpButtonW, sortDownButtonW, vsep2W, sortingTableW, sortingCandidatesTableW, addSortButtonW, removeSortButtonW, sortCandidateLabel, sortColumnsLabel, removeAllSortButtonW };

        createWidgetsLayout();
        createWidgetsTabOrder();

        if(getDialog()==this) {
            shell.setSize(scaler.convertXToCurrent(660), scaler.convertYToCurrent(520));
        }
    }

    /**
     * Create the layout of all SWT-Widgets of the page.
     * (Attachments, Distances, Sizes)
     */
    public void createWidgetsLayout() {
        FormData data;
        final Scaler scaler = getScaler();
        data = new FormData();
        data.width = scaler.convertXToCurrent(140);
        data.right = new FormAttachment(cancelButtonW,scaler.convertXToCurrent(-3),SWT.LEFT);
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        applyAndPersistButtonW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(140);
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(-3));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        cancelButtonW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(140);
        data.right = new FormAttachment(applyAndPersistButtonW,scaler.convertXToCurrent(-3),SWT.LEFT);
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        applyButtonW.setLayoutData(data);

        data = new FormData();
        data.height = scaler.convertYToCurrent(190);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(-3));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        uiGroupW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(20));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(-3));
        availableColumnsW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(availableColumnsW,scaler.convertXToCurrent(3),SWT.LEFT);
        data.bottom = new FormAttachment(availableColumnsW,scaler.convertYToCurrent(-3),SWT.TOP);
        availableColumnsL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(addButtonW,scaler.convertXToCurrent(10),SWT.RIGHT);
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(20));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(-3));
        visibleColumnsTableW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(25);
        data.height = scaler.convertYToCurrent(25);
        data.left = new FormAttachment(availableColumnsW,scaler.convertXToCurrent(10),SWT.RIGHT);
        data.top = new FormAttachment(vsep1W,scaler.convertYToCurrent(0),SWT.TOP);
        addButtonW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(25);
        data.height = scaler.convertYToCurrent(25);
        data.left = new FormAttachment(availableColumnsW,scaler.convertXToCurrent(10),SWT.RIGHT);
        data.bottom = new FormAttachment(vsep1W,scaler.convertYToCurrent(-3),SWT.BOTTOM);
        removeButtonW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(visibleColumnsTableW,scaler.convertXToCurrent(3),SWT.LEFT);
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        visibleColumnsL.setLayoutData(data);

        data = new FormData();
        data.height = scaler.convertYToCurrent(55);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(230));
        data.top = new FormAttachment(availableColumnsW,scaler.convertYToCurrent(0),SWT.CENTER);
        vsep1W.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(25);
        data.height = scaler.convertYToCurrent(25);
        data.left = new FormAttachment(visibleColumnsTableW,scaler.convertXToCurrent(10),SWT.RIGHT);
        data.top = new FormAttachment(vsep1W,scaler.convertYToCurrent(3),SWT.TOP);
        upButtonW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(25);
        data.height = scaler.convertYToCurrent(25);
        data.left = new FormAttachment(upButtonW,scaler.convertXToCurrent(0),SWT.CENTER);
        data.top = new FormAttachment(upButtonW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        downButtonW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(80);
        data.left = new FormAttachment(visibleColumnsTableW,scaler.convertXToCurrent(10),SWT.RIGHT);
        data.top = new FormAttachment(visibleColumnsTableW,scaler.convertYToCurrent(0),SWT.TOP);
        setFilterButtonW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(80);
        data.left = new FormAttachment(visibleColumnsTableW,scaler.convertXToCurrent(10),SWT.RIGHT);
        data.top = new FormAttachment(setFilterButtonW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        removeFilterButtonW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(removeFilterButtonW,scaler.convertXToCurrent(0),SWT.LEFT);
        data.bottom = new FormAttachment(visibleColumnsTableW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        removeAllFilterButtonW.setLayoutData(data);

        data = new FormData();
        data.height = scaler.convertYToCurrent(190);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(-3));
        data.top = new FormAttachment(uiGroupW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        sortGroupW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(25);
        data.height = scaler.convertYToCurrent(25);
        data.left = new FormAttachment(sortingTableW,scaler.convertXToCurrent(10),SWT.RIGHT);
        data.top = new FormAttachment(vsep2W,scaler.convertYToCurrent(3),SWT.TOP);
        sortUpButtonW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(25);
        data.height = scaler.convertYToCurrent(25);
        data.left = new FormAttachment(sortingTableW,scaler.convertXToCurrent(10),SWT.RIGHT);
        data.top = new FormAttachment(sortUpButtonW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        sortDownButtonW.setLayoutData(data);

        data = new FormData();
        data.height = scaler.convertYToCurrent(55);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(230));
        data.top = new FormAttachment(sortingCandidatesTableW,scaler.convertYToCurrent(0),SWT.CENTER);
        vsep2W.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(addSortButtonW,scaler.convertXToCurrent(10),SWT.RIGHT);
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(20));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(-3));
        sortingTableW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(20));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(-3));
        sortingCandidatesTableW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(25);
        data.height = scaler.convertYToCurrent(25);
        data.left = new FormAttachment(sortingCandidatesTableW,scaler.convertXToCurrent(10),SWT.RIGHT);
        data.top = new FormAttachment(vsep2W,scaler.convertYToCurrent(0),SWT.TOP);
        addSortButtonW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(25);
        data.height = scaler.convertYToCurrent(25);
        data.left = new FormAttachment(sortingCandidatesTableW,scaler.convertXToCurrent(10),SWT.RIGHT);
        data.bottom = new FormAttachment(vsep2W,scaler.convertYToCurrent(0),SWT.BOTTOM);
        removeSortButtonW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(3));
        sortCandidateLabel.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(sortingTableW,scaler.convertXToCurrent(3),SWT.LEFT);
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(3));
        sortColumnsLabel.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(sortDownButtonW,scaler.convertXToCurrent(0),SWT.LEFT);
        data.bottom = new FormAttachment(sortingTableW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        removeAllSortButtonW.setLayoutData(data);

    }

    /**
     * Create the tab order of all SWT-Widgets of the page.
     * (sets the focus and defines the tab order)
     */
    protected void createWidgetsTabOrder() {
        Control[] tabOrder;
        final Shell shell = getShell();
        final Composite customizerPageCompW = getComposite();
        if(getDialog()==this) {
            shell.setTabList(new Control[] { customizerPageCompW });
        }
        tabOrder = new Control[5];
        tabOrder[0] = applyAndPersistButtonW;
        tabOrder[1] = cancelButtonW;
        tabOrder[2] = applyButtonW;
        tabOrder[3] = uiGroupW;
        tabOrder[4] = sortGroupW;
        customizerPageCompW.setTabList(tabOrder);
        tabOrder = new Control[9];
        tabOrder[0] = availableColumnsW;
        tabOrder[1] = visibleColumnsTableW;
        tabOrder[2] = addButtonW;
        tabOrder[3] = removeButtonW;
        tabOrder[4] = upButtonW;
        tabOrder[5] = downButtonW;
        tabOrder[6] = setFilterButtonW;
        tabOrder[7] = removeFilterButtonW;
        tabOrder[8] = removeAllFilterButtonW;
        uiGroupW.setTabList(tabOrder);
        tabOrder = new Control[7];
        tabOrder[0] = sortUpButtonW;
        tabOrder[1] = sortDownButtonW;
        tabOrder[2] = sortingTableW;
        tabOrder[3] = sortingCandidatesTableW;
        tabOrder[4] = addSortButtonW;
        tabOrder[5] = removeSortButtonW;
        tabOrder[6] = removeAllSortButtonW;
        sortGroupW.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        applyAndPersistButtonW = null;
        cancelButtonW = null;
        applyButtonW = null;
        uiGroupW = null;
        availableColumnsW = null;
        availableColumnsL = null;
        visibleColumnsTableW = null;
        addButtonW = null;
        removeButtonW = null;
        visibleColumnsL = null;
        vsep1W = null;
        upButtonW = null;
        downButtonW = null;
        setFilterButtonW = null;
        removeFilterButtonW = null;
        removeAllFilterButtonW = null;
        sortGroupW = null;
        sortUpButtonW = null;
        sortDownButtonW = null;
        vsep2W = null;
        sortingTableW = null;
        sortingCandidatesTableW = null;
        addSortButtonW = null;
        removeSortButtonW = null;
        sortCandidateLabel = null;
        sortColumnsLabel = null;
        removeAllSortButtonW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        TableColumn[] cols;
        availableColumnsW.setData(availableColumns.getUIDelegate());
        availableColumns.getUIDelegate().attachUI(availableColumnsW,availableColumnsL);
        visibleColumnsTableW.setData(visibleColumnsTable.getUIDelegate());
        visibleColumnsTable.getUIDelegate().attachUI(visibleColumnsTableW,null);
        cols = visibleColumnsTableW.getColumns();
        for(int i = 0; i<cols.length; i++) {
            cols[i].setData(visibleColumnsTable.getUIDelegate());
        }
        if (visibleColumnsTableW.getMenu() != null) {
           for(MenuItem item : visibleColumnsTableW.getMenu().getItems()) {
               item.setData(visibleColumnsTable.getUIDelegate());
           }
        }

        sortingTableW.setData(sortingTable.getUIDelegate());
        sortingTable.getUIDelegate().attachUI(sortingTableW,null);
        cols = sortingTableW.getColumns();
        for(int i = 0; i<cols.length; i++) {
            cols[i].setData(sortingTable.getUIDelegate());
        }
        if (sortingTableW.getMenu() != null) {
           for(MenuItem item : sortingTableW.getMenu().getItems()) {
               item.setData(sortingTable.getUIDelegate());
           }
        }

        sortingCandidatesTableW.setData(sortingCandidatesTable.getUIDelegate());
        sortingCandidatesTable.getUIDelegate().attachUI(sortingCandidatesTableW,null);
        cols = sortingCandidatesTableW.getColumns();
        for(int i = 0; i<cols.length; i++) {
            cols[i].setData(sortingCandidatesTable.getUIDelegate());
        }
        if (sortingCandidatesTableW.getMenu() != null) {
           for(MenuItem item : sortingCandidatesTableW.getMenu().getItems()) {
               item.setData(sortingCandidatesTable.getUIDelegate());
           }
        }

    }

    /**
     * This method will be called every time the TableCustomizerPage becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
        if (event.widget == applyAndPersistButtonW) {
            applyAndPersistButtonWEvent();
        } else if (event.widget == cancelButtonW) {
            cancelButtonWEvent();
        } else if (event.widget == applyButtonW) {
            applyButtonWEvent();
        } else if (event.widget == addButtonW) {
            addButtonWEvent();
        } else if (event.widget == removeButtonW) {
            removeButtonWEvent();
        } else if (event.widget == upButtonW) {
            upButtonWEvent();
        } else if (event.widget == downButtonW) {
            downButtonWEvent();
        } else if (event.widget == setFilterButtonW) {
            setFilterButtonWEvent();
        } else if (event.widget == removeFilterButtonW) {
            removeFilterButtonWEvent();
        } else if (event.widget == removeAllFilterButtonW) {
            removeAllFilterButtonWEvent();
        } else if (event.widget == sortUpButtonW) {
            sortUpButtonWEvent();
        } else if (event.widget == sortDownButtonW) {
            sortDownButtonWEvent();
        } else if (event.widget == sortingTableW  && type == SWT.Selection) {
            sortingTableWSelected();
        } else if (event.widget == sortingTableW  && type == SWT.DefaultSelection) {
            sortingTableWDoubleClick();
        } else if (event.widget == sortingCandidatesTableW  && type == SWT.Selection) {
            sortingCandidatesTableWSelected();
        } else if (event.widget == addSortButtonW) {
            addSortButtonWEvent();
        } else if (event.widget == removeSortButtonW) {
            removeSortButtonWEvent();
        } else if (event.widget == removeAllSortButtonW) {
            removeAllSortButtonWEvent();
        }
    }

    /**
     * This method will be called every time the user clicks on applyAndPersistButtonW.
     */
    abstract protected void applyAndPersistButtonWEvent();

    /**
     * This method will be called every time the user clicks on cancelButtonW.
     */
    abstract protected void cancelButtonWEvent();

    /**
     * This method will be called every time the user clicks on applyButtonW.
     */
    abstract protected void applyButtonWEvent();

    /**
     * This method will be called every time the user clicks on addButtonW.
     */
    abstract protected void addButtonWEvent();

    /**
     * This method will be called every time the user clicks on removeButtonW.
     */
    abstract protected void removeButtonWEvent();

    /**
     * This method will be called every time the user clicks on upButtonW.
     */
    abstract protected void upButtonWEvent();

    /**
     * This method will be called every time the user clicks on downButtonW.
     */
    abstract protected void downButtonWEvent();

    /**
     * This method will be called every time the user clicks on setFilterButtonW.
     */
    abstract protected void setFilterButtonWEvent();

    /**
     * This method will be called every time the user clicks on removeFilterButtonW.
     */
    abstract protected void removeFilterButtonWEvent();

    /**
     * This method will be called every time the user clicks on removeAllFilterButtonW.
     */
    abstract protected void removeAllFilterButtonWEvent();

    /**
     * This method will be called every time the user clicks on sortUpButtonW.
     */
    abstract protected void sortUpButtonWEvent();

    /**
     * This method will be called every time the user clicks on sortDownButtonW.
     */
    abstract protected void sortDownButtonWEvent();

    /**
     * This method will be called every time the user selects an item in sortingTableW.
     */
    abstract protected void sortingTableWSelected();

    /**
     * This method will be called every time the user doubleclicks on an item in sortingTableW.
     */
    abstract protected void sortingTableWDoubleClick();

    /**
     * This method will be called every time the user selects an item in sortingCandidatesTableW.
     */
    abstract protected void sortingCandidatesTableWSelected();

    /**
     * This method will be called every time the user clicks on addSortButtonW.
     */
    abstract protected void addSortButtonWEvent();

    /**
     * This method will be called every time the user clicks on removeSortButtonW.
     */
    abstract protected void removeSortButtonWEvent();

    /**
     * This method will be called every time the user clicks on removeAllSortButtonW.
     */
    abstract protected void removeAllSortButtonWEvent();

}
